__kernel void %KERNEL_NAME%(global int *xbuf) {
  int x = get_global_id(0), y = get_global_id(1), p0 = (y << %SHIFT%) + x;
  int g = xbuf[p0];

  if (g != 0) {
    bool ow = false;
    int s, og = g;

    /*
    prefetch(&xbuf[((y - 1) << %SHIFT%) + x], sizeof(int));
    prefetch(&xbuf[((y + 1) << %SHIFT%) + x], sizeof(int));
    prefetch(&xbuf[(y << %SHIFT%) + x - 1], sizeof(int) * 3);
    */

    s = xbuf[((y - 1) << %SHIFT%) + x];
    if (s != 0 && s < g) { g = s; ow = true; }

    s = xbuf[((y + 1) << %SHIFT%) + x];
    if (s != 0 && s < g) { g = s; ow = true; }

    s = xbuf[(y << %SHIFT%) + x - 1];
    if (s != 0 && s < g) { g = s; ow = true; }

    s = xbuf[(y << %SHIFT%) + x + 1];
    if (s != 0 && s < g) { g = s; ow = true; }

    s = xbuf[g];
    if (s != g) {
      ow = true;
      g = s;
      s = xbuf[g];
      if (s != g) {
	g = s;
	s = xbuf[g];
	if (s != g) {
	  g = xbuf[s];
	}
      }
    }

    if (ow) {
      /*
      xbuf[og] = min(xbuf[og], g);
      xbuf[p0] = min(xbuf[p0], g);
      */

      atomic_min(&xbuf[og], g);
      atomic_min(&xbuf[p0], g);
    }
  }
}
