package org.naokishibata.examples;

import java.awt.image.*;

import org.naokishibata.ocvimgio.*;
import org.naokishibata.generic.*;

public class CVTest2 {
    public static void main(String[] args) throws Exception {
	Scribble2D s0 = null, s1 = null;

	CvCapture c0 = CvCapture.cvCreateCameraCapture(0);

	if (c0 == null) System.exit(-1);

	c0.cvSetCaptureProperty(CvCapture.CV_CAP_PROP_FRAME_WIDTH , 640);
	c0.cvSetCaptureProperty(CvCapture.CV_CAP_PROP_FRAME_HEIGHT, 480);
	s0 = new Scribble2D();
	s0.makeFrame("Camera 0");
	s0.setExitWhenClosed(true);

	for(;;) {
	    IplImage iimg = c0.cvQueryFrame();
	    BufferedImage bimg = iimg.getImage();
	    s0.drawImage(0, 0, bimg);

	    Thread.sleep(100);
	}
    }
}
