__kernel void %KERNEL_NAME%(__global read_only int *src, __global write_only int *dstx, __global write_only int *dsty, __global write_only int *dstm) {
  int x = get_global_id(0), y = get_global_id(1), adr = (y << %SHIFT%) + x;
  int xout = 0, yout = 0, c;

  c = src[((y-1) << %SHIFT%) + x - 1]; xout += -1 * c; yout += -1 * c;
  c = src[((y-1) << %SHIFT%) + x    ];                 yout += -2 * c;
  c = src[((y-1) << %SHIFT%) + x + 1]; xout +=  1 * c; yout += -1 * c;
  c = src[((y  ) << %SHIFT%) + x - 1]; xout += -2 * c;
  c = src[((y  ) << %SHIFT%) + x + 1]; xout +=  2 * c;
  c = src[((y+1) << %SHIFT%) + x - 1]; xout += -1 * c; yout +=  1 * c;
  c = src[((y+1) << %SHIFT%) + x    ];                 yout +=  2 * c;
  c = src[((y+1) << %SHIFT%) + x + 1]; xout +=  1 * c; yout +=  1 * c;

  dstx[adr] = xout;
  dsty[adr] = yout;
  dstm[adr] = xout * xout + yout * yout;
}
