package org.naokishibata.generic;

import javax.swing.filechooser.*;
import java.io.*;
import java.util.regex.*;

public class RegexFileFilter extends javax.swing.filechooser.FileFilter implements FilenameFilter {
    final String regex, description;

    public RegexFileFilter(String s, String desc) { regex = s; description = desc; }

    public boolean accept(File f) { return f.isDirectory() || Pattern.matches(regex, f.getName()); }

    public boolean accept(File dir, String name) { return Pattern.matches(regex, name); }

    public String getDescription() { return description; }
}
